<id>
MemberMap SP 1.3.1 - 1.4
</id>

<version>
3.0
</version>

<mod info>

Instructions:

Apply the mod

Upload (in ASCII mode):
english.lng
Sources/Admin.pl
Sources/AdminEdit.pl
Sources/Display.pl
Sources/Profile.pl
Sources/Register.pl
Sources/Subs.pl
Sources/SubList.pl

Upload the MemberMap.pl file to your Sources folder.

Upload (in ASCII mode) to your Variables folder and chmod to 666:
state.txt

Upload (in Binary mode):
The .gif and .cur images to your Images folder.

Upload the "flag" folder with all the flags to your YaBBImages folder (in binary mode)
Upload the "maps" folder with all the maps to your YaBBImages folder (in binary mode)

Go to Admin Center - Forum Preferences and Settings - check the MemberMap settings and click the Save button.

MemberMap 3.0 for SP 1.3

This mod adds a map-function to YaBB for members to "pin" their location on a map.

Features:

Everybody can (guests only if allowed by Admin):
-view location of members on the main-map
-click on a members pin to view the members profile
-click on a name in the name list in main-map to make the members pin flash
-view members map in members "View Profile"

Members and Adnim can:
-select map, type location, select State/Region* and Country
-point and click on a map to place a pin where they live
-edit their location at any time from "View Profile"
-remove pin from map

Admin can:
-admin can make location required on registration from Admin-Center
-add own maps
-change the name, number and order of maps
-add/delete countries and flags
-add/delete states/regions
-allow/disallow guest access to member map
-allow/disallow state/region selection
-sort the main-map name list by country or name
-view hide index-headers in name list
-allow/disallow gender-colored pins from Admin-Center
-If gender-color disallowed, admin can choose red, green or blue pin color
-set view/hide location in posts as flag, text or both from Admin-Center

*if enabled by Admin.


Included in the zip file:

-MemberMap.pl
-MemberMap.mod
-state.txt (120 states/regions/territories in USA, Canada, Australia, Germany, Austria and Switzerland)
-9 maps in .gif format
-204 flags in .gif format

-YaMS 4.02 MemberMap-column add-on

New Maps:

If you want to add new Maps they must be 550x430 pixels .gif format and should have a meaningfull name 
(use underline for spaces ex.: New_Zealand.gif). Upload the new map to your Images folder, and go to 
"Admin-center - Member Controls - Setup Member Map" and transfere the Map to the "active" maps list.
In order to make room for the pins there must be at least 4 pixel "no mans land" at the left and 10 pixel 
at the top of the map.
</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>

# MemberMap

%maptxt = (
'01' => "Member Map",
'02' => "Select Map",
'03' => "Location",
'04' => "Select Country",
'05' => "Point and click on the map where you live.",
'06' => " Save ",
'07' => " View ",
'08' => "Setup Member Map",
'09' => "Add/reorder/remove Maps",
'10' => "Add/reorder/remove Countries",
'11' => "(Edit from View-Profile)",
'12' => "Edit Member Map",
'13' => "Allow Guests to view Member Map",
'14' => "View location in Posts",
'15' => "View index-headers in name list",
'16' => "Sort name list by",
'17' => "Name",
'18' => "Country",
'19' => "Add/reorder/remove States (one per line)",
'20' => "for States use - Initials,State<br />for Country-header use - xxx,Country",
'21' => "Select State/Region (optional)",
'22' => "Close",
'23' => "Allow State/Region selection",
'24' => "You should fill in a location.",
'25' => "Location may only contain numbers and letters (example: 8900 Randers)",
'26' => "You should select a country.",
'27' => "Require location on registration",
'28' => "Flag",
'29' => "Text",
'30' => "Show gender-color on Member Map",
'31' => "Pin-color if gender-color un-selected",
'32' => "Add your location",
'33' => "Add all",
'34' => "Reset",
'35' => "Press 'Ctrl' or 'Shift' for multiple selection",
'36' => "Absolute Path to your MemberMap maps",
'37' => "Absolute Path to your MemberMap flags"
);

</add after>

<search for>
	$img{'website_sm'} = qq~<font size="1" class="imgwindowbg">$txt{'515'}</font>~;
</search for>

<add after>
	$img{'membermap'} = qq~<font size="1" class="imgwindowbg">$maptxt{'01'}</font>~;
</add after>

<search for>
else {
	$menusep = ' ';
</search for>

<add after>
	$img{'membermap'} = qq~<img src="$imagesdir/map.gif" alt="$maptxt{'01'}" title="$maptxt{'01'}" border="0" /> <font size="1" class="imgmenu">$maptxt{'01'}</font>~;
</add after>


<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=setreserve">$txt{'207'}</a>
</search for>

<replace>
        - <a href="$cgi;action=setreserve">$txt{'207'}</a><br />
        - <a href="$cgi;action=setmembmap">$maptxt{'08'}</a>
</replace>


<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub EditNews {
</search for>

<add before>
$mapvers = "MemberMap 3.0";
require "$sourcedir/MemberMap.pl";

</add before>


<search for>
sub SetCensor {
</search for>

<add before>
sub SetMembermap {
	&is_admin;
	my(@lines, $cnmaps, $maps, $i);
	$mapcount = 0;
	opendir(DIR, "$mapsdir") || fatal_error("$txt{'230'} ($mapsdir)!");
	@contents = readdir(DIR);
	closedir(DIR);
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		if ($extension =~ /gif/i){
			$maps .= qq~<option value="$name">$name</option>\n~;
			$mapcount++;
		}
	}

	fopen(FILE, "$vardir/continent.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		if($i == 0) {$cnmaps .= "$lines[$i]";}
		else {$cnmaps .= "\n$lines[$i]";}
	}

	my(@lines, $countr, $flags, $i);
	$flagcount = 0;
	opendir(DIR, "$flagdir") || fatal_error("$txt{'230'} ($flagdir)!");
	@flcontents = readdir(DIR);
	closedir(DIR);
	foreach $flline (sort @flcontents){
		($flname, $flextension) = split (/\./, $flline);
		if ($flextension =~ /gif/i){
			$flags .= qq~<option value="$flname">$flname</option>\n~;
			$flagcount++;
		}
	}

	fopen(FILE, "$vardir/country.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		if($i == 0) {$countr .= "$lines[$i]";}
		else {$countr .= "\n$lines[$i]";}
	}

	my(@lines, $stat, $i);
	fopen(FILE, "$vardir/state.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$stat .= "$lines[$i]\n";
	}

$yymain .= qq~
<table width="410" cellspacing="0" cellpadding="0" align="center">
	<tr>
	<td align="left">
	<fieldset class="windowbg2" style="padding: 4px;">
		<legend align="left"><img src="$imagesdir/map.gif" hspace="3" alt="" border="0" align="middle" /><span>$maptxt{'09'}</span></legend>
		<font size="1">
		$maptxt{'35'}
		</font>
	</fieldset>
	</td>
	</tr>
	<tr>
	<td align="center">
	<fieldset class="windowbg" style="margin-bottom: 8px; padding: 4px;">
		<form name="selectmaps" action="$cgi;action=setmembmap2" method="post" style="display: inline">
		<select name="selmaps" size="9" style="width: 170px; font-size: 10px; margin: 2px;" multiple="multiple">
		$maps
		</select>
		<input type="button" value="\-\>" style="margin-bottom: 50px" onclick="addmap($mapcount)" />
		<textarea name="maps" cols="29" rows="9" style="width: 170px; font-size: 10px; margin: 2px">$cnmaps</textarea>
		<br />
		<input type="button" value="$maptxt{'33'}" style="width: 100px;" onclick="addall($mapcount)" /><input type="button" value="$maptxt{'34'}" style="width: 100px;" onclick="resetadd()" /><input type="submit" value="$txt{'10'}" style="width: 100px;" />
		</form>
	</fieldset>
	</td>
	</tr>
	<tr>
	<td align="left">
	<fieldset class="windowbg2" style="padding: 4px;">
		<legend align="left"><img src="$imagesdir/map.gif" hspace="3" alt="" border="0" align="middle" /><span>$maptxt{'10'}</span></legend>
		<font size="1">
		$maptxt{'35'}
		</font>
	</fieldset>
	</td>
	</tr>
	<tr>
	<td align="center">
	<fieldset class="windowbg" style="margin-bottom: 8px; padding: 4px;">
		<form name="selectflags" action="$cgi;action=setcountry2" method="post" style="display: inline">
		<select name="selflags" size="9" style="width: 170px; font-size: 10px; margin: 2px;" multiple="multiple">
		$flags
		</select>
		<input type="button" value="\-\>" style="margin-bottom: 50px" onclick="addflag($flagcount)" />
		<textarea name="country" cols="29" rows="9" style="width: 170px; font-size: 10px; margin: 2px">$countr</textarea>
		<br />
		<input type="button" value="$maptxt{'33'}" style="width: 100px;" onclick="addallflag($flagcount)" /><input type="button" value="$maptxt{'34'}" style="width: 100px;" onclick="resetaddflag()" /><input type="submit" value="$txt{'10'}" style="width: 100px;" />
		</form>
	</fieldset>
	</td>
	</tr>
	<tr>
	<td align="left">
	<fieldset class="windowbg2" style="padding: 4px;">
		<legend align="left"><img src="$imagesdir/map.gif" hspace="3" alt="" border="0" align="middle" /><span>$maptxt{'19'}</span></legend>
		<font size="1">
		$maptxt{'20'}
		</font>
	</fieldset>
	</td>
	</tr>
	<tr>
	<td align="center">
	<fieldset class="windowbg" style="margin-bottom: 8px; padding: 4px;">
		<form action="$cgi;action=setstate2" method="post" style="display: inline">
		<textarea name="states" cols="40" rows="9" style="width: 300px; font-size: 10px; margin: 2px">$stat</textarea>
		<br />
		<input type="submit" value="$txt{'10'}" style="width: 100px;" />
		</form>
	</fieldset>
	</td>
	</tr>
</table>

<script language="JavaScript1.2" type="text/javascript">
<!--
function addmap(numb) {
var nline = '';
var ncount = 0;
	for(i=0;i<numb;i++) {
		if (document.selectmaps.maps.value != '') nline = '\\n';
		if (document.selectmaps.selmaps.options[i].selected) {
			document.selectmaps.maps.value += nline + document.selectmaps.selmaps.options[i].value;
			ncount++;
		}
	}
	if(ncount > 1) document.selectmaps.selmaps.selectedIndex = 0;
}

function addall(numb) {
	document.selectmaps.maps.value = document.selectmaps.selmaps.options[0].value;
	for(i=1;i<numb;i++) { document.selectmaps.maps.value += '\\n' + document.selectmaps.selmaps.options[i].value; }
}

function resetadd() {
	document.selectmaps.maps.value = '';
	document.selectmaps.selmaps.selectedIndex = 0;
}

function addflag(numb) {
var nline = '';
var ncount = 0;
	for(i=0;i<numb;i++) {
		if (document.selectflags.country.value != '') nline = '\\n';
		if (document.selectflags.selflags.options[i].selected) {
			document.selectflags.country.value += nline + document.selectflags.selflags.options[i].value;
			ncount++;
		}
	}
	if(ncount > 1) document.selectflags.selflags.selectedIndex = 0;
}

function addallflag(numb) {
	document.selectflags.country.value = document.selectflags.selflags.options[0].value;
	for(i=1;i<numb;i++) { document.selectflags.country.value += '\\n' + document.selectflags.selflags.options[i].value; }
}

function resetaddflag() {
	document.selectflags.country.value = '';
	document.selectflags.selflags.selectedIndex = 0;
}

//-->
</script>

~;
	$yytitle = $maptxt{'08'};
	&template;
	exit;
}

sub SetMembermap2 {
	&is_admin;
	my $maps = $FORM{'maps'};
	while( $conts = each(%FORM) ) {
		$FORM{$conts} =~ tr/\n//d;
		$FORM{$conts} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/continent.txt", 1);
	print FILE "$maps";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetCountry2 {
	&is_admin;
	my $country = $FORM{'country'};
	while( $contr = each(%FORM) ) {
		$FORM{$contr} =~ tr/\n//d;
		$FORM{$contr} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/country.txt", 1);
	print FILE "$country";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetState2 {
	&is_admin;
	my $states = $FORM{'states'};
	while( $sstate = each(%FORM) ) {
		$FORM{$sstate} =~ tr/\n//d;
		$FORM{$sstate} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/state.txt", 1);
	print FILE "$states";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

</add before>

<search for>
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
</search for>

<add after>
	my($smapguest_allow, $sview_flag, $sview_text, $sview_state, $smapsort_name, $smapsort_country, $smapsort_index, $sreq_location, $sview_mapgender);
	my($sred_pin, $sgreen_pin, $sblue_pin);
</add after>

<search for>
	if ($allowpics) { $allowpicschecked = "checked" }
</search for>

<add after>
	if ($view_state) { $sview_state = "checked" }
	if ($mapsort_index) { $smapsort_index = "checked" }
	if ($mapsort eq "name") { $smapsort_name = 'checked' } else { $smapsort_country = 'checked' }
	if ($mapguest_allow) { $smapguest_allow = "checked" }
	if ($view_flag) { $sview_flag = "checked" }
	if ($view_text) { $sview_text = "checked" }
	if ($req_location) { $sreq_location = "checked" }
	if ($view_mapgender) { $sview_mapgender = "checked" }
	if ($mappin eq "rpin") { $sred_pin = 'checked' } elsif ($mappin eq "gpin") { $sgreen_pin = 'checked' } else { $sblue_pin = 'checked' }

	if(!$mapsdir) {
		$imagdir = rindex($facesdir,"/");
		$mapsdir = substr($facesdir,0,$imagdir);
		$mapsdir = qq~$mapsdir/maps~;
	}

	if(!$flagdir) {
		$imagdir = rindex($facesdir,"/");
		$flagdir = substr($facesdir,0,$imagdir);
		$flagdir = qq~$flagdir/flag~;
	}

</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'591'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="godmem" size="5" value="$GodPostNum"></td>
</search for>

<add after>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/map.gif" alt="" border="0" align="middle" /> <font size="2" color="$color{'titletext'}"><b>$maptxt{'01'}</b></font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'36'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="mapsdir" size="35" value="$mapsdir" /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'37'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="flagdir" size="35" value="$flagdir" /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'27'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="req_location" $sreq_location /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'23'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_state" $sview_state /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapsort_index" $smapsort_index /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'16'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mapsort" value="name" $smapsort_name /><font size="2">$maptxt{'17'} &nbsp;</font>
		<input type=radio name="mapsort" value="country" $smapsort_country /><font size="2">$maptxt{'18'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'13'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapguest_allow" $smapguest_allow /></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'14'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_flag" $sview_flag /><font size="2">$maptxt{'28'} </font> <input type=checkbox name="view_text" $sview_text /><font size="2">$maptxt{'29'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'30'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mapgender" $sview_mapgender/></td>

  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mappin" value="rpin" $sred_pin /> <img src="$imagesdir/rpin.gif" alt="" border="0" align="middle" /> &nbsp;
		<input type=radio name="mappin" value="gpin" $sgreen_pin /> <img src="$imagesdir/gpin.gif" alt="" border="0" align="middle" /> &nbsp;
		<input type=radio name="mappin" value="bpin" $sblue_pin /> <img src="$imagesdir/bpin.gif" alt="" border="0" align="middle" /></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>$mapvers</I></b> &nbsp;</font><a href=http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl?board=;action=pgratinglink;editmode=new;itemlink=1050347017 target=_blank><img src="http://www.cd-profil.dk/yabb/mm13ver.gif" border="0" align="middle" /><br /></a></td>
</add after>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add before>
	push(@onoff, "view_state", "mapsort_index", "mapsort", "mapguest_allow", "view_flag", "view_text", "req_location", "view_mapgender", "rpin", "gpin", "bpin");
</add before>

<search for>
	$timeselected = $FORM{'timeselect'} || 0;
</search for>

<add after>
	$mapsdir = $FORM{'mapsdir'};
	$mapsdir =~ s~\s+$~~;
	$flagdir = $FORM{'flagdir'};
	$flagdir =~ s~\s+$~~;
	$mapsort = $FORM{'mapsort'} || 'name';
	$mappin = $FORM{'mappin'} || 'rpin';
</add after>

<search for>
\$helpfile = "$helpfile";				# URL to your help file
</search for>

<add after>

\$mapsdir = '$mapsdir';		  				# Absolute path to the MemberMap maps
\$flagdir = '$flagdir';		  				# Absolute path to the MemberMap flags
</add after>

<search for>
\$allow_hide_email = $allow_hide_email;			# Allow users to hide their email from public. Set 0 to disable
</search for>

<add after>
\$req_location = $req_location;	     			# Set to 1 to require location on registration
\$view_state = $view_state;		     			# Set to 0 to disallow State/Region selection in Member Map
\$mapsort_index = $mapsort_index;	     			# Set to 0 to hide index-headers in name-list in Member Map
\$mapsort = $mapsort;			     			# Set to country or name to sort name-list in Member Map by Country or Name
\$mapguest_allow = $mapguest_allow;	     			# Set to 0 to disallow guests to view Member Map
\$view_flag = $view_flag;		     			# Set to 0 to hide flags in Posts and Profile
\$view_text = $view_text;		     			# Set to 0 to hide location in Posts and Profile
\$view_mapgender = $view_mapgender;	     			# Set to 0 to hide location in Posts and Profile
\$mappin = $mappin;			     			# Set to rpin for red pins, gpin for green pins or bpin for blue pins on Member Map
</add after>


<edit file>
Sources/Display.pl
</edit file>

<search for>
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
</search for>

<add after>
			my($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate, $dispflag, $disptext);
</add after>

<search for>
			@userprofile = @{$userprofile{$musername}};
</search for>

<add after>
	($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate) = split(/\|/, $userprofile[15]);
	if($dispcountry ne "") {
		if($view_flag) {
			if($loccode eq "x1") { $dispflag = qq~<a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap"><img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="middle" alt="$dispcountry" /></a>&nbsp;~; }
			elsif($loccode eq "x0") { $dispflag = qq~<img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="middle" alt="$dispcountry" />&nbsp;~; }
			else { $dispflag = ""; }
		}
		if($view_text) {
			my($initstat, $namestat, $disploc);
			if($dispstate ne "") { ($initstat, $namestat) = split(/\,/, $dispstate); }
			if($displocal ne "") { $disploc = qq~$displocal $initstat~; }
			if($loccode eq "x1") { $disptext = qq~<nobr><font size="1"><a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap">$disploc</a></font></nobr>~; }
			elsif($loccode eq "x0") { $disptext = qq~<nobr><font size="1">$disploc</font></nobr>~; }
			else { $disptext = ""; }
		}
	}
</add after>

<search for>
	if($musername ne "Guest") {
		$yymain .= qq~
</search for>

<replace>
	if($musername ne "Guest") {
		if($view_flag) { $yymain .= qq~$dispflag ~; }
		if($view_text) { $yymain .= qq~$disptext~; }
		if($view_flag || $view_text) { $yymain .= qq~<br />~; }
		$yymain .= qq~
</replace>


<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$memsettings[9] =~ tr/+/ /;
	$memsettings[10] =~ tr/+/ /;
</search for>

<add after>
	my($maptest);
	if($memsettings[15] ne "") {
		$maptest = substr($memsettings[15],0,2);
	}
</add after>

<search for>
	<td width="320"><font size=2><b>$txt{'227'}: </b></font></td>
	<td><font size=2><input type="text" maxlength="30" name="location" size="50" value="$memsettings[15]"></font></td>
      </tr><tr>
</search for>

<replace>
~;
if($maptest eq "x0") {

	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			if($curcountry eq $profcountry) { $selektet = ' selected' }
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}

	if($profcountry eq "") { $thisflag = "Noflag" }
	else { $thisflag = $profcountry }

	fopen(FILE, "$vardir/state.txt");
	@state = <FILE>;
	fclose(FILE);
	chomp @state;
	foreach $curstate (@state) {
		$curstate =~ s/ //gi;
		$curstate =~ s/\n//gi;
		$curstate =~ s/\r//gi;
		$selektet = "";
		($stateval, $stateopt) = split(/\,/, $curstate);
		if($profstate eq $curstate) { $selektet = ' selected' }
		$stateopt =~ s/\_/ /g;
		if($stateval eq "xxx") {
			$statopt .= qq~<option value="">\n~;
			$statopt .= qq~<option value="">$stateopt\n~;
			$statopt .= qq~<option value="">---------------\n~;
		}
		else { $statopt .= qq~<option value="$curstate"$selektet>$stateopt\n~; }
	}

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24" value="$proflocal" /></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
	      </tr>
		~;
	}
	$yymain .= qq~
	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>

	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>

	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border="0" hspace="15" alt="" />
	<input type="hidden" name="kode" value="$loccode" />

	<input type="hidden" name="contselect" value="$profcontin" />
	<input type="hidden" name="xcoord" value="$profx" />
	<input type="hidden" name="ycoord" value="$profy" /></td>
      </tr><tr>
~;

}
elsif($maptest eq "x1") {
	my($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate, $initstate, $namestate, $viewloc);
	($loccode, $proflocal, $profcountry, $profcontin, $profx, $profy, $profstate) = split(/\|/, $memsettings[15]);
	$thiscountry = $profcountry;
	$thiscountry =~ s/\_/ /g;
	($initstate, $namestate) = split(/\,/, $profstate);
	my($prlocal, $inistate);
	if($proflocal ne "") { $prlocal .= qq~$proflocal,~; } else { $prlocal = ""; }
	if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }
	$viewloc = qq~$prlocal $inistate $thiscountry~;

	$yymain .= qq~
	<td width="320"><font size=2><b>$txt{'227'}:</b> $maptxt{'11'}</font></td>
	<td><font size=2>$viewloc</font><img src="$imagesdir/flag/$profcountry.gif" border="0" hspace="15" alt="" />
	<input type="hidden" name="kode" value="$loccode" />
	<input type="hidden" name="cityloc" value="$proflocal" />
	~;
	if($view_state) {
		$yymain .= qq~
		<input type="hidden" name="mapstate" value="$profstate" />
		~;
	}
	$yymain .= qq~
	<input type="hidden" name="mapcountry" value="$profcountry" />
	<input type="hidden" name="contselect" value="$profcontin" />
	<input type="hidden" name="xcoord" value="$profx" />
	<input type="hidden" name="ycoord" value="$profy" /></td>
      </tr><tr>
~;
}
else {
	my($loccode, $profcontin, $profx, $profy, $profstate);

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}
	if($view_state) {
		fopen(FILE, "$vardir/state.txt");
		@state = <FILE>;
		fclose(FILE);
		chomp @state;
			foreach $curstate (@state) {
				$curstate =~ s/ //gi;
				$curstate =~ s/\n//gi;
				$curstate =~ s/\r//gi;
				($stateval, $stateopt) = split(/\,/, $curstate);
				$stateopt =~ s/\_/ /g;
				if($stateval eq "xxx") {
					$statopt .= qq~<option value="">\n~;
					$statopt .= qq~<option value="">$stateopt\n~;
					$statopt .= qq~<option value="">---------------\n~;
				}
				else { $statopt .= qq~<option value="$curstate">$stateopt\n~; }
			}
	}

	$thisflag = "Noflag";

	$yymain .= qq~
	<td width="320"><font size=2><b>$maptxt{'03'}: </b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24" /></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td width="320"><font size=2><b>$maptxt{'21'}: </b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
      	</tr>
		~;
	}
	$yymain .= qq~

	<tr>
	<td width="320"><font size=2><b>$maptxt{'04'}: </b></font></td>
	<td>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>
	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border="0" hspace="15" alt="" />
	<input type="hidden" name="kode" value="x0" />

	<input type="hidden" name="contselect" value="$profcontin" />
	<input type="hidden" name="xcoord" value="$profx" />
	<input type="hidden" name="ycoord" value="$profy" /></td>
      </tr><tr>
~;

}
	$yymain .= qq~
</replace>

<search for>
		&ToHTML($member{'location'});
</search for>

<replace>
		if($member{'mapcountry'} eq "Noflag") { $member{'mapcountry'} = "" }
		&ToHTML($member{'cityloc'});
		if($view_state) { &ToHTML($member{'mapstate'}); }
		&ToHTML($member{'mapcountry'});
		&ToHTML($member{'contselect'});
		&ToHTML($member{'xcoord'});
		&ToHTML($member{'ycoord'});
</replace>

<search for>
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
</search for>

<add before>
if($member{'kode'} eq "x0" || $member{'kode'} eq "x1") {
	$memblocal = $member{'cityloc'};
	if($view_state) { $membstate = $member{'mapstate'} }
	else { $membstate = "" }
	$membcountry = $member{'mapcountry'};
	$membcontinent = $member{'contselect'};
	$membx = $member{'xcoord'};
	$memby = $member{'ycoord'};
	$loccode = $member{'kode'};
	$member{'location'} .= qq($loccode|$memblocal|$membcountry|$membcontinent|$membx|$memby|$membstate);
}
else {
	$member{'location'} = "x0";
}
</add before>

<search for>
	my($memberinfo, $modify, $email, $gender, $pic);
</search for>

<replace>
	my($memberinfo, $modify, $email, $gender, $pic, $modifyloc, $prolocal, $prostate, $procountry, $initstate, $namestate);
</replace>

<search for>
	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
</search for>

<replace>
	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$theuser = $INFO{'username'};
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
		$modifyloc = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2 class="text1" color="$color{'titletext'}">$maptxt{'12'}</font></a> &#187;~;
		$modifyloc1 = qq~&#171; <a href=javascript:MapEditwin('$cgi&action=mmedit&username=$theuser')><font size=2>$maptxt{'12'}</font></a> &#187;~;
	}
</replace>


<search for>
      </tr><tr>
        <td><font size=2><b>$txt{'227'}: </b></font></td>
        <td><font size=2>$memsettings[15]</font></td>
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font></td>
  </tr><tr height="25">
</search for>

<replace>
<script language="JavaScript1.2" type="text/javascript">
<!--
	function MapEditwin(FileName,WindowName) {
		WindowFeature="Resizable=No,ScrollBars=No,MenuBar=No,Directories=No,ToolBar=No,Location=No,Status=No,Width=762,Height=431,ScreenX=0,ScreenY=0,Top=0,Left=0"
		newWindow=open(FileName,WindowName,WindowFeature);
		if (newWindow.opener == null) { newWindow.opener = self; }
		if (newWindow.focus) { newWindow.focus(); }
	}
//-->
</script>
~;
if($view_mapgender) {
	if($memsettings[11] eq "Male") {
		$pin = "bpin";
	}
	elsif($memsettings[11] eq "Female") {
		$pin = "rpin";
	}
	else {
		$pin = "gpin";
	}
}
else {
	$pin = $mappin;
}

my($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate, $initstate, $namestate, $viewmembname, $viewloc);
$membx = 0; $memby = 0; $membcontinent = "";
($loccode, $memblocal, $membcountry, $membcontinent, $membx, $memby, $membstate) = split(/\|/, $memsettings[15]);
($initstate, $namestate) = split(/\,/, $membstate);
my($prlocal, $inistate);
if($memblocal ne "") { $prlocal .= qq~$memblocal,~; } else { $prlocal = ""; }
if($initstate ne "") { $inistate .= qq~$initstate,~; } else { $inistate = ""; }

if($view_flag) {
	if($membcountry ne "") { $theflag = qq~<img src="$imagesdir/flag/$membcountry.gif" border="0" hspace="5" alt="" align="middle">~; }
}
else { $theflag = ""; }

$thiscountry = $membcountry;
$thiscountry =~ s/\_/ /g;

if($loccode eq "x0" || $loccode eq "x1") {
	my($thislocal, $thisstate);
	if($memblocal ne "") { $thislocal .= qq~$memblocal,~; }
	else { $thislocal = ""; }
	if($initstate ne "") { $thisstate .= qq~$initstate,~; }
	else { $thisstate = ""; }
	$viewloc = qq~<font size=2>$thislocal $thisstate $thiscountry</font>$theflag~;
}
else { $viewloc = qq~<font size=2>&nbsp;</font>~; }

if($loccode eq "x1") {
$yymain .= qq~
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<br /><br />
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;

fopen(FILE, "$vardir/continent.txt");
@continent = <FILE>;
fclose(FILE);
foreach (@continent) { $_ =~ s~[\n\r]~~g; }
if($membcontinent eq "") {
	$memcontinent = $continent[0];
}
else {
	foreach $cname (@continent){
		if(lc $cname eq lc $membcontinent) { $memcontinent = $cname; }
	}
}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
  img1 = new Image();
  img1.src = "$imagesdir/bpin.gif";
  img2 = new Image();
  img2.src = "$imagesdir/gpin.gif";
  img3 = new Image();
  img3.src = "$imagesdir/rpin.gif";
// -->
</script>
<tr>
<td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
    <table border="0" cellspacing="0" cellpadding="4" width="100%">
      <tr>
	<td align="left" width="25%">
        <a name="mmap"><font size="2" class="text1" color="$color{'titletext'}">$txt{'227'}:</font></a></td>
	<td align="left" width="45%">
        <font size=2 class="text1" color="$color{'titletext'}">$viewloc</font></td>
	<td align="center" width="30%">
        <font size=2 class="text1" color="$color{'titletext'}">$modifyloc</font></td>
      </tr>
    </table>
</td>
</tr><tr>
<td colspan="2" align="center" bgcolor="#AFC6DB">
<div id="map" style="position: relative; overflow: hidden; width: 550px; height: 430px; cursor: default;">
	<img src="$imagesdir/maps/$memcontinent.gif" id="aktmap" name="mapview" width="550" height="430" style="position: relative; z-index: 0;" alt="" />
	<img src="$imagesdir/$pin.gif" id="memloc" style="z-index: 1; border: 0;" alt="" />
</div>
</td>
</tr>

<script language="JavaScript1.2" type="text/javascript">

var useNS6 = document.getElementById && !document.all ? 1:0;

	document.images.mapview.src="$imagesdir/maps/$memcontinent.gif";

	if (document.all) {
		document.all.map.style.cursor = "default";
		document.all.memloc.style.position = "absolute";
		document.all.memloc.style.top = $memby - 9;
		document.all.memloc.style.left = $membx - 3;
		document.all.memloc.style.visibility="visible";
	}
	if(useNS6) {
		document.getElementById("map").style.cursor = "default";
		document.getElementById("memloc").style.position = "absolute";
		document.getElementById("memloc").style.top = $memby - 9;
		document.getElementById("memloc").style.left = $membx - 3;
		document.getElementById("memloc").style.visibility = "visible";
	}

</script>
~;
}
else {
$yymain .= qq~
      </tr><tr>
        <td><font size=2><b>$txt{'227'}:</b></font></td>
        <td>$viewloc</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>$modifyloc1</td>
	</tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<br /><br />
    <font size=1>$memsettings[12]</font></td>
  </tr>
~;
}
$yymain .= qq~
  <tr height="25">
</replace>


<edit file>
Sources/Register.pl
</edit file>

<search for>
        <td><font size=2><input type=password maxlength="30" name=passwrd2 size=30></font></td>
      </tr>
~;
}
</search for>

<add after>
if($req_location) {
	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	fclose(FILE);
	chomp @country;
		foreach $curcountry (sort @country) {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt\n~;
		}
	if($view_state) {
		fopen(FILE, "$vardir/state.txt");
		@state = <FILE>;
		fclose(FILE);
		chomp @state;
			foreach $curstate (@state) {
				$curstate =~ s/ //gi;
				$curstate =~ s/\n//gi;
				$curstate =~ s/\r//gi;
				($stateval, $stateopt) = split(/\,/, $curstate);
				$stateopt =~ s/\_/ /g;
				if($stateval eq "xxx") {
					$statopt .= qq~<option value="">\n~;
					$statopt .= qq~<option value="">$stateopt\n~;
					$statopt .= qq~<option value="">---------------\n~;
				}
				else { $statopt .= qq~<option value="$curstate">$stateopt\n~; }
			}
	}

	$thisflag = "Noflag";

	$yymain .= qq~
	<tr><td><font size=2>* <b>$maptxt{'03'}:</b></font></td>
	<td><font size=2><input style="font-size: 9pt;" type="text" maxlength="30" name="cityloc" size="24" /></font></td>
      </tr>
	~;
	if($view_state) {
		$yymain .= qq~
		<tr>
		<td><font size=2><b>$maptxt{'21'}:</b></font></td>
		<td><font size=2><select style="font-size: 9pt;" name="mapstate"><option value="">$statopt</select></font></td>
      	</tr>
		~;
	}
	$yymain .= qq~

	<tr>
	<td><font size=2>* <b>$maptxt{'04'}:</b></font></td>
	<td>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function showflag() {
	   document.images.flags.src="$imagesdir/flag/"+document.creator.mapcountry.options[document.creator.mapcountry.selectedIndex].value+".gif";
	}
	//-->
	</script>
	<font size=2><select style="font-size: 9pt;" name="mapcountry" onChange="showflag()"><option value="Noflag">$cntropt</select></font><img src="$imagesdir/flag/$thisflag.gif" name="flags" border="0" hspace="15" alt="" />
      </tr>
~;
}
</add after>

<search for>
	&fatal_error("($member{'username'}) $txt{'76'}") if($member{'email'} eq "");
	&fatal_error("($member{'username'}) $txt{'100'}") if(-e ("$memberdir/$member{'username'}.dat"));
</search for>

<add after>
if($req_location) {
	&fatal_error("($member{'username'}) $maptxt{'24'}") if($member{'cityloc'} eq '');
	&fatal_error("($member{'username'}) $maptxt{'25'}") if($member{'cityloc'} eq '_' || $member{'cityloc'} eq '|');
	&fatal_error("$txt{'240'} $maptxt{'03'} $txt{'241'}") if($member{'cityloc'} !~ /\A[0-9A-Za-z#%+-\.@^_ ]+\Z/);
	&fatal_error("($member{'username'}) $maptxt{'26'}") if($member{'mapcountry'} eq '');
}
</add after>

<search for>
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n\n\n\n\n";
</search for>

<replace>
if($req_location) {
	$memblocal = $member{'cityloc'};
	if($view_state) { $membstate = $member{'mapstate'} }
	else { $membstate = "" }
	$membcountry = $member{'mapcountry'};
	$membcontinent = "";
	$membx = 0;
	$memby = 0;
	$loccode = "x0";
	$member{'location'} .= qq($loccode|$memblocal|$membcountry|$membcontinent|$membx|$memby|$membstate);
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n";
	print FILE "$member{'location'}\n\n\n\n";
}
else {
	print FILE "\n\n\n0\n\n\n\n\n\n$txt{'209'}\nblank.gif\n$date\n\n\n\n\n";
}
</replace>


<edit file>
Sources/SubList.pl
</edit file>

<search for>
'ml',"Admin.pl&ml",
</search for>

<add after>
'mmall',"MemberMap.pl&MMall",
'mmall2',"MemberMap.pl&MMall2",
'mmedit',"MemberMap.pl&MMedit",
'mmedit2',"MemberMap.pl&MMedit2",
</add after>

<search for>
'search2',"Search.pl&plushSearch2",
</search for>

<add after>
'setmembmap',"AdminEdit.pl&SetMembermap",
'setmembmap2',"AdminEdit.pl&SetMembermap2",
'setcountry2',"AdminEdit.pl&SetCountry2",
'setstate2',"AdminEdit.pl&SetState2",
</add after>


<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";
</search for>

<add before>
fopen(FILE, "$vardir/continent.txt");
@continent = <FILE>;
fclose(FILE);
chomp @continent;
$defaultmap = $continent[0];
</add before>

<search for>
	if($settings[7] eq 'Administrator') { $yymenu .= qq~$menusep<a href="$cgi;action=admin">$img{'admin'}</a>~; }
</search for>

<add before>
		$yymenu .= qq~$menusep<a href="$cgi;action=mmall;defmap=$defaultmap">$img{'membermap'}</a>~;
</add before>
